| TagLib 1.13 |  |

Public Types | Public Member Functions | Static Public Member Functions | List of all members
TagLib::FLAC::File Class Reference

An implementation of TagLib::File with FLAC specific methods. More...

`#include <flacfile.h>`

Inheritance diagram for TagLib::FLAC::File:
[legend]
Collaboration diagram for TagLib::FLAC::File:
[legend]

## Public Types
enum | TagTypes { NoTags = 0x0000 , XiphComment = 0x0001 , ID3v1 = 0x0002 , ID3v2 = 0x0004 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions
| File (FileName file, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
| File (FileName file, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
| File (IOStream *stream, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
virtual | ~File ()
virtual TagLib::Tag * | tag () const
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &)
PropertyMap | setProperties (const PropertyMap &)
virtual Properties * | audioProperties () const
virtual bool | save ()
ID3v2::Tag * | ID3v2Tag (bool create=false)
ID3v1::Tag * | ID3v1Tag (bool create=false)
Ogg::XiphComment * | xiphComment (bool create=false)
TAGLIB_DEPRECATED void | setID3v2FrameFactory (const ID3v2::FrameFactory *factory)
TAGLIB_DEPRECATED ByteVector | streamInfoData ()
TAGLIB_DEPRECATED long | streamLength ()
List< Picture * > | pictureList ()
void | removePicture (Picture *picture, bool del=true)
void | removePictures ()
void | addPicture (Picture *picture)
void | strip (int tags=AllTags)
bool | hasXiphComment () const
bool | hasID3v1Tag () const
bool | hasID3v2Tag () const
Public Member Functions inherited from TagLib::File
virtual | ~File ()
FileName | name () const
virtual Tag * | tag () const =0
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &properties)
PropertyMap | setProperties (const PropertyMap &properties)
virtual AudioProperties * | audioProperties () const =0
virtual bool | save ()=0
ByteVector | readBlock (unsigned long length)
void | writeBlock (const ByteVector &data)
long | find (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
long | rfind (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, unsigned long start=0, unsigned long replace=0)
void | removeBlock (unsigned long start=0, unsigned long length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (long offset, Position p=Beginning)
void | clear ()
long | tell () const
long | length ()

## Static Public Member Functions
static bool | isSupported (IOStream *stream)
Static Public Member Functions inherited from TagLib::File
static TAGLIB_DEPRECATED bool | isReadable (const char *file)
static TAGLIB_DEPRECATED bool | isWritable (const char *name)

## Additional Inherited Members
Protected Member Functions inherited from TagLib::File
| File (FileName file)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (long length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with FLAC specific methods.

This implements and provides an interface for FLAC files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to FLAC files.

## Member Enumeration Documentation

## ◆ TagTypes

enum TagLib::FLAC::File::TagTypes

This set of flags is used for various operations and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
XiphComment | Matches Vorbis comments.
ID3v1 | Matches ID3v1 tags.
ID3v2 | Matches ID3v2 tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## ◆ File() [1/3]

TagLib::FLAC::File::File | ( | FileName | file,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | propertiesStyle = `Properties::Average`
| ) |  |

Constructs a FLAC file from file. If readProperties is true the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

Deprecated:
  This constructor will be dropped in favor of the one below in a future version.

## ◆ File() [2/3]

TagLib::FLAC::File::File | ( | FileName | file,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | propertiesStyle = `Properties::Average`
| ) |  |

Constructs an FLAC file from file. If readProperties is true the file's audio properties will also be read.

If this file contains and ID3v2 tag the frames will be created using frameFactory.

Note
  In the current implementation, propertiesStyle is ignored.

## ◆ File() [3/3]

TagLib::FLAC::File::File | ( | IOStream * | stream,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | propertiesStyle = `Properties::Average`
| ) |  |

Constructs a FLAC file from stream. If readProperties is true the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

If this file contains and ID3v2 tag the frames will be created using frameFactory.

Note
  In the current implementation, propertiesStyle is ignored.

## ◆ ~File()

virtual TagLib::FLAC::File::~File | ( |  | ) |
| virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## Member Function Documentation

## ◆ addPicture()

void TagLib::FLAC::File::addPicture | ( | Picture * | picture | ) |

Add a new picture to the file. The file takes ownership of the picture and will handle freeing its memory.

Note
  The file will be saved only after calling save().

## ◆ audioProperties()

virtual Properties * TagLib::FLAC::File::audioProperties | ( |  | ) | const
| virtual

Returns the FLAC::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

## ◆ hasID3v1Tag()

bool TagLib::FLAC::File::hasID3v1Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v1 tag.

See also
  ID3v1Tag()

## ◆ hasID3v2Tag()

bool TagLib::FLAC::File::hasID3v2Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v2 tag.

See also
  ID3v2Tag()

## ◆ hasXiphComment()

bool TagLib::FLAC::File::hasXiphComment | ( |  | ) | const

Returns whether or not the file on disk actually has a XiphComment.

See also
  xiphComment()

## ◆ ID3v1Tag()

ID3v1::Tag * TagLib::FLAC::File::ID3v1Tag | ( | bool | create = `false` | ) |

Returns a pointer to the ID3v1 tag of the file.

If create is false (the default) this returns a null pointer if there is no valid APE tag. If create is true it will create an APE tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v1 tag. Use hasID3v1Tag() to check if the file on disk actually has an ID3v1 tag.
  The Tag is still owned by the MPEG::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v1Tag()

## ◆ ID3v2Tag()

ID3v2::Tag * TagLib::FLAC::File::ID3v2Tag | ( | bool | create = `false` | ) |

Returns a pointer to the ID3v2 tag of the file.

If create is false (the default) this returns a null pointer if there is no valid ID3v2 tag. If create is true it will create an ID3v2 tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v2 tag. Use hasID3v2Tag() to check if the file on disk actually has an ID3v2 tag.
  The Tag is still owned by the MPEG::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v2Tag()

## ◆ isSupported()

static bool TagLib::FLAC::File::isSupported | ( | IOStream * | stream | ) |
| static

Returns whether or not the given stream can be opened as a FLAC file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

## ◆ pictureList()

List< Picture * > TagLib::FLAC::File::pictureList | ( |  | ) |

Returns a list of pictures attached to the FLAC file.

## ◆ properties()

PropertyMap TagLib::FLAC::File::properties | ( |  | ) | const

Implements the unified property interface – export function. If the file contains more than one tag (e.g. XiphComment and ID3v1), only the first one (in the order XiphComment, ID3v2, ID3v1) will be converted to the PropertyMap.

## ◆ removePicture()

void TagLib::FLAC::File::removePicture | ( | Picture * | picture,
|  | bool | del = `true`
| ) |  |

Removes an attached picture. If del is true the picture's memory will be freed; if it is false, it must be deleted by the user.

## ◆ removePictures()

void TagLib::FLAC::File::removePictures | ( |  | ) |

Remove all attached images.

## ◆ removeUnsupportedProperties()

void TagLib::FLAC::File::removeUnsupportedProperties | ( | const StringList & |  | ) |

## ◆ save()

virtual bool TagLib::FLAC::File::save | ( |  | ) |
| virtual

Save the file. This will primarily save the XiphComment, but will also keep any old ID3-tags up to date. If the file has no XiphComment, one will be constructed from the ID3-tags.

This returns true if the save was successful.

Implements TagLib::File.

## ◆ setID3v2FrameFactory()

TAGLIB_DEPRECATED void TagLib::FLAC::File::setID3v2FrameFactory | ( | const ID3v2::FrameFactory * | factory | ) |

Set the ID3v2::FrameFactory to something other than the default. This can be used to specify the way that ID3v2 frames will be interpreted when

See also
  ID3v2FrameFactory

Deprecated:
  This value should be passed in via the constructor.

## ◆ setProperties()

PropertyMap TagLib::FLAC::File::setProperties | ( | const PropertyMap & |  | ) |

Implements the unified property interface – import function. This always creates a Xiph comment, if none exists. The return value relates to the Xiph comment only. Ignores any changes to ID3v1 or ID3v2 comments since they are not allowed in the FLAC specification.

## ◆ streamInfoData()

TAGLIB_DEPRECATED ByteVector TagLib::FLAC::File::streamInfoData | ( |  | ) |

Returns the block of data used by FLAC::Properties for parsing the stream properties.

Deprecated:
  Always returns an empty vector.

## ◆ streamLength()

TAGLIB_DEPRECATED long TagLib::FLAC::File::streamLength | ( |  | ) |

Returns the length of the audio-stream, used by FLAC::Properties for calculating the bitrate.

Deprecated:
  Always returns zero.

## ◆ strip()

void TagLib::FLAC::File::strip | ( | int | tags = `AllTags` | ) |

This will remove the tags that match the OR-ed together TagTypes from the file. By default it removes all tags.

Warning
  This will also invalidate pointers to the tags as their memory will be freed.

Note
  In order to make the removal permanent save() still needs to be called.
  This won't remove the Vorbis comment block completely. The vendor ID will be preserved.

## ◆ tag()

virtual TagLib::Tag * TagLib::FLAC::File::tag | ( |  | ) | const
| virtual

Returns the Tag for this file. This will be a union of XiphComment, ID3v1 and ID3v2 tags.

See also
  ID3v2Tag()
  ID3v1Tag()
  XiphComment()

Implements TagLib::File.

## ◆ xiphComment()

Ogg::XiphComment * TagLib::FLAC::File::xiphComment | ( | bool | create = `false` | ) |

Returns a pointer to the XiphComment for the file.

If create is false (the default) this returns a null pointer if there is no valid XiphComment. If create is true it will create a XiphComment if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has a XiphComment. Use hasXiphComment() to check if the file on disk actually has a XiphComment.
  The Tag is still owned by the FLAC::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasXiphComment()

The documentation for this class was generated from the following file:

- flacfile.h